【13.77%】【codeforces 734C】Anton and Making Potions

time limit per test4 seconds
memory limit per test256 megabytes
inputstandard input
outputstandard output
Anton is playing a very interesting computer game, but now he is stuck at one of the levels. To pass to the next level he has to prepare n potions.

Anton has a special kettle, that can prepare one potions in x seconds. Also, he knows spells of two types that can faster the process of preparing potions.

Spells of this type speed up the preparation time of one potion. There are m spells of this type, the i-th of them costs bi manapoints and changes the preparation time of each potion to ai instead of x.
Spells of this type immediately prepare some number of potions. There are k such spells, the i-th of them costs di manapoints and instantly create ci potions.
Anton can use no more than one spell of the first type and no more than one spell of the second type, and the total number of manapoints spent should not exceed s. Consider that all spells are used instantly and right before Anton starts to prepare potions.

Anton wants to get to the next level as fast as possible, so he is interested in the minimum number of time he needs to spent in order to prepare at least n potions.

Input
The first line of the input contains three integers n, m, k (1 ≤ n ≤ 2·109, 1 ≤ m, k ≤ 2·105) — the number of potions, Anton has to make, the number of spells of the first type and the number of spells of the second type.

The second line of the input contains two integers x and s (2 ≤ x ≤ 2·109, 1 ≤ s ≤ 2·109) — the initial number of seconds required to prepare one potion and the number of manapoints Anton can use.

The third line contains m integers ai (1 ≤ ai < x) — the number of seconds it will take to prepare one potion if the i-th spell of the first type is used.

The fourth line contains m integers bi (1 ≤ bi ≤ 2·109) — the number of manapoints to use the i-th spell of the first type.

There are k integers ci (1 ≤ ci ≤ n) in the fifth line — the number of potions that will be immediately created if the i-th spell of the second type is used. It’s guaranteed that ci are not decreasing, i.e. ci ≤ cj if i < j.

The sixth line contains k integers di (1 ≤ di ≤ 2·109) — the number of manapoints required to use the i-th spell of the second type. It’s guaranteed that di are not decreasing, i.e. di ≤ dj if i < j.

Output
Print one integer — the minimum time one has to spent in order to prepare n potions.

Examples
input
20 3 2
10 99
2 4 3
20 10 40
4 15
10 80
output
20
input
20 3 2
10 99
2 4 3
200 100 400
4 15
100 800
output
200
Note
In the first sample, the optimum answer is to use the second spell of the first type that costs 10 manapoints. Thus, the preparation time of each potion changes to 4 seconds. Also, Anton should use the second spell of the second type to instantly prepare 15 potions spending 80 manapoints. The total number of manapoints used is 10 + 80 = 90, and the preparation time is 4·5 = 20 seconds (15 potions were prepared instantly, and the remaining 5 will take 4 seconds each).

In the second sample, Anton can’t use any of the spells, so he just prepares 20 potions, spending 10 seconds on each of them and the answer is 20·10 = 200.

【题目链接】:http://codeforces.com/contest/734/problem/C

【题解】

分两种情况;
1.只用第二种魔法;
2.用第一种魔法,第二种魔法不一定用;
第1种就二分下第二种魔法;找到最大的可以接受的di;因为di,ci都是单增的所以这个di对应的ci也即最优解;
第二种就先枚举第一种魔法用哪一种;然后用新的x和剩余的魔法值去尝试第二种魔法(当然也要二分);
那些不二分的人是怎么想的。
终测84%之后就变成龟速了…我想大概就是第三题不写二分的结果吧。时限4s误导了大家?:)

【完整代码】

#include <bits/stdc++.h>
#define LL long long

using namespace std;

const int MAXMK = 2e5+10;

int n,m,k;
LL x,s;
LL a[MAXMK],d[MAXMK],b[MAXMK];
int c[MAXMK];

int getmax(LL rest)
{
    int l = 1,r = k,ans = -1;
    while (l <= r)
    {
        int m = (l+r)>>1;
        if (d[m] <= rest)
            ans = m,l = m+1;
        else
            r = m-1;
    }
    return ans;
}

int main()
{
    //freopen("F:\rush.txt","r",stdin);
    cin >> n >> m >> k;
    cin >> x >> s;
    for (int i = 1;i <= m;i++)
        cin >> a[i];
    for (int i = 1;i <= m;i++)
        cin >> b[i];
    for (int i = 1;i <= k;i++)
        cin >> c[i];
    for (int i = 1;i <= k;i++)
        cin >> d[i];

    LL ans1 = -1;
    //只用第二种
    int pos = getmax(s);
    if (pos!=-1)
    {
        int rest = n-c[pos];
        ans1 = rest*x;
    }

    //用第一种,再看第二种要用不用
    LL ans2 = -1;
    for (int i = 1;i <= m;i++)
    {
        LL tx = x,ts = s;
        if (b[i] <= ts)
        {
            ts-=b[i];
            tx=a[i];
            int pos1 = getmax(ts);
            if (pos1!=-1)
            {
                int rest = n-c[pos1];
                if (ans2 == -1)
                    ans2 = rest*tx;
                else
                    ans2 = min(ans2,rest*tx);
            }
            else
                if (ans2 == -1)
                    ans2 = 1LL*n*tx;
                else
                    ans2 = min(ans2,1LL*n*tx);
        }
    }
    if (ans1 == -1 && ans2 ==-1)
        cout << 1LL*n*x<<endl;
    else
        if (ans1 == -1 && ans2!=-1)
            cout << ans2 << endl;
    else
        if (ans1 !=-1 && ans2 == -1)
            cout << ans1 << endl;
        else
            cout << min(ans1,ans2)<<endl;
    return 0;
}
原文地址:https://www.cnblogs.com/AWCXV/p/7632056.html